#define WIN31
#include <owl.h>
#include <bbutton.h>
#include <bwcc.h>
#include "Toolbar.h"
// Main Window
class ToolBarWindow:public TWindow
{
public:
	ToolBarWindow(PTWindowsObject AParent);
	virtual void GetWindowClass(WNDCLASS &AWndClass);
	virtual void Paint(HDC PaintDC, PAINTSTRUCT _FAR & PaintInfo);
	virtual void IconOne(RTMessage)=[ID_FIRST + ID_ICONONE];
	virtual void IconTwo(RTMessage)=[ID_FIRST + ID_ICONTWO];
	virtual void IconThree(RTMessage)=[ID_FIRST + ID_ICONTHREE];
	virtual void IconFour(RTMessage)=[ID_FIRST + ID_ICONFOUR];
	void StatusMessage(LPSTR msg);
};
ToolBarWindow::ToolBarWindow(PTWindowsObject AParent):
	TWindow(AParent,"Toolbar Test")
{
	new TBButton(this,ID_ICONONE,"",1 ,1,21,21,0);
	new TBButton(this,ID_ICONTWO,"",25,1,21,21,0);
	new TBButton(this,ID_ICONTHREE,"",50,1,21,21,0);
	new TBButton(this,ID_ICONFOUR,"",75,1,21,21,0);
}
void ToolBarWindow::GetWindowClass(WNDCLASS &AWndClass)
{
	TWindow::GetWindowClass(AWndClass);
	AWndClass.hbrBackground=BWCCGetPattern();
}
void ToolBarWindow::Paint(HDC PaintDC, PAINTSTRUCT _FAR & PaintInfo)
{
	int iBarHeight=25;
	// draw window first by calling TWindow class
	TWindow::Paint(PaintDC,PaintInfo);

	// draw toolbar
    RECT R;
	GetClientRect(HWindow,&R);
	SelectObject(PaintInfo.hdc,GetStockObject(LTGRAY_BRUSH));
	Rectangle(PaintInfo.hdc,0,0,R.right-R.left,iBarHeight);
	// draw status bar
	SelectObject(PaintInfo.hdc,GetStockObject(LTGRAY_BRUSH));
	Rectangle(PaintInfo.hdc,R.left,R.bottom-iBarHeight,
	R.right,R.bottom);
	StatusMessage("Status msg");

}
void ToolBarWindow::IconOne(RTMessage)
{
	BWCCMessageBox(HWindow,"You pressed Icon One","Info",
	MB_ICONINFORMATION | MB_YESNO);
}
void ToolBarWindow::IconTwo(RTMessage)
{
	BWCCMessageBox(HWindow,"You pressed Icon Two","Stop",
	MB_ICONSTOP | MB_ABORTRETRYIGNORE);
}
void ToolBarWindow::IconThree(RTMessage)
{
	BWCCMessageBox(HWindow,"You pressed Icon Three","See!",
	MB_ICONEXCLAMATION | MB_YESNOCANCEL);
}
void ToolBarWindow::IconFour(RTMessage)
{
	BWCCMessageBox(HWindow,"You pressed Icon Four","Why ?",
	MB_ICONQUESTION);
}
void ToolBarWindow::StatusMessage(LPSTR msg)
{
	RECT R;
	GetClientRect(HWindow,&R);
	HDC hDC = GetDC(HWindow);
	SetTextAlign(hDC,TA_BOTTOM);
	SetTextColor(hDC,0);//black
	SetBkMode(hDC,TRANSPARENT);
	TextOut(hDC,2,R.bottom-2,msg,lstrlen(msg));
	ReleaseDC(HWindow,hDC);
}
// Application
class ToolBarApp :public TApplication
{
public:
  ToolBarApp(LPSTR AName, HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
    : TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow) {};
  virtual void InitMainWindow();
};
void ToolBarApp::InitMainWindow()
{
  MainWindow = new ToolBarWindow(NULL);
}
// Entry point
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
	BWCCGetVersion();	
	ToolBarApp HelloApp ("HelloApp", hInstance, hPrevInstance,lpCmdLine, nCmdShow);
	HelloApp.Run();
	return HelloApp.Status;
}
